unit coaGenl;

// Copyright  2001 by Ziff Davis Media, Inc.
// Written by Neil J. Rubenking

interface
const
  MainMapName = 'PC Magazine COA2 Shared';
  b : String = '&nbsp;&nbsp;';
    // main page status constants
  redblankOld          = 7;
  redblankNew          = 8;
  redblankBoth         = 9;
  redinvalidOld        = 10;
  redinvalidNew        = 11;
  redinvalidBoth       = 12;
  rednoexistNew        = 13;
  rednoexistBoth       = 14;
  grnExistNew          = 15;
  grnExistBoth         = 16;
  yelIdentical         = 17; // both exist
  yelIdentiCase        = 18; // both exist
  yelFoldNoSlashExNew  = 19;
  yelFoldNoSlashExBoth = 20;
  yelOldSlashExNew     = 21;
  yelOldSlashExBoth    = 22;
  yelNewSlashExNew     = 23;
  yelNewSlashExBoth    = 24;
  yelOldFoldNewFile    = 25;
  yelOldFileNewFold    = 26;
  yelOldDriveNewNot    = 27;
  yelNewDriveOldNot    = 28;
  // change/undo Status constants
  statBlank = 0;
  statCheck = 1;
  statUndoX = 2;
  statUndOK = 3;
  statFaild = 4;
  statNSafe = 5;
  statFaildData = $010; // Registry - could not write data
  statFaildWrit = $020; // Registry - could not open to write
  statFaildSame = $030; // Registry - value name already exists
  statFaildName = $040; // Registry - could not rename
  statFaildArgs = $050; // shortcut - could not change arguments
  statFaildWork = $060; // shortcut - could not change workdir
  statFaildIcon = $070; // shortcut - could not change iconloc
  statFaildPath = $080; // shortcut - could not change path
  statFaildSavL = $090; // shortcut - could not save to disk
  statFaildSavI = $0A0; // ini file - could not save to disk
  statNsafeBina = $0B0; // regiatry - binary data
  statNSafeRKey = $0C0; // registry - key name
  statUndoxSect = $0D0; // ini file - could not find section
  statUndoxKeyK = $0E0; // ini file - could not find key
  statUndoxKeyS = $0F0; // ini file - could not find section for key
  statUndoxDatK = $100; // ini file - could not find key
  statUndoxDatS = $110; // ini file - could not find section for key
  // change type constants
  chgNone       = 0;
  chgIniSection = 1;
  chgLnkCommand = 2;
  chgLnkIconloc = 3;
  chgLnkWorkDir = 4;
  chgLnkArgs    = 5;
  chgIniKey     = 6;
  chgRegKey     = 6;
  chgRegValue   = 7;
  chgIniData    = 8;
  chgRegData    = 8;
  chgLast       = chgRegData;

CHGFullNames : ARRAY[chgNone..chgLast] OF String = ('error',
  'Section', 'Command', 'Icon location', 'Working directory',
  'Arguments', 'Key', 'Value', 'Data');

implementation
end.
