unit mainu;

// Copyright  2001 by Ziff Davis Media, Inc.
// Written by Neil J. Rubenking

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ImgList, ComCtrls, ExtCtrls, StdCtrls, Buttons, OleCtrls,
  SHDocVw;

const
  cUndoMax = 9;
type
  TMainForm = class(TForm)
    nbMain: TNotebook;
      // old and new addresses
        btnOldFold      : TBitBtn;
        btnOldFile      : TBitBtn;
        ebOldLong       : TEdit;
        btnDn           : TBitBtn;
        btnNewFold      : TBitBtn;
        btnNewFile      : TBitBtn;
        ebNewLong       : TEdit;
        btnUp           : TBitBtn;
        btnDesc         : TBitBtn;
        ebDesc          : TEdit;
        sbStatus        : TBitBtn;
        ebStatus        : TEdit;
        btnReview       : TBitBtn;
        btnChange       : TBitBtn;
      // short filenames
        ebOldCopy       : TEdit;
        ebOldShrt       : TEdit;
        ebNewCopy       : TEdit;
        ebNewShrt       : TEdit;
        lblShort        : TLabel;
        cbNoShort       : TCheckBox;
        btnBack1        : TBitBtn;
        btnChange2      : TBitBtn;
      // searching
        pnlLnkSearched  : TPanel;
        pnlIniSearched  : TPanel;
        pnlRegSearched  : TPanel;
        pnlLnkFound     : TPanel;
        pnlIniFound     : TPanel;
        pnlRegFound     : TPanel;
        pnlAnimate      : TPanel;
          anChange      : TAnimate;
      // review change records
        pnlDescM        : TPanel;
          pnlRecNum     : TPanel;
          pnlDesc       : TPanel;
          lvMain        : TListView;
        pnlReviewUndo   : TPanel;
          btnAll        : TBitBtn;
          btnNone       : TBitBtn;
          btnUndo       : TBitBtn;
          btnNext       : TBitBtn;
          btnPrev       : TBitBtn;
          btnDelRec     : TBitBtn;
          btnReport     : TBitBtn;
          btnToMain     : TBitBtn;
      // detail report
        nbRept          : TNotebook;
          // text page
          reRept        : TRichEdit;
          // html page
            lblRept     : TLabel;
        pnlReptText     : TPanel;
          btnBack2      : TBitBtn;
          btnLaunch     : TBitBtn;
    pnlButtons          : TPanel;
      Bevel1            : TBevel;
      btnClose          : TButton;
      btnHelp           : TButton;
      btnAbout          : TButton;
    sbMain              : TStatusBar;
    ilTypes             : TImageList;
    ilChecks            : TImageList;
    OpenDialog1         : TOpenDialog;
    SaveDialog1         : TSaveDialog;
    procedure FormActivate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure nbMainMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure btnOldFoldClick(Sender: TObject);
    procedure btnOldFileClick(Sender: TObject);
    procedure ebOldLongChange(Sender: TObject);
    procedure btnDnClick(Sender: TObject);
    procedure btnNewFoldClick(Sender: TObject);
    procedure btnNewFileClick(Sender: TObject);
    procedure ebNewLongChange(Sender: TObject);
    procedure btnUpClick(Sender: TObject);
    procedure btnDescClick(Sender: TObject);
    procedure ebDescChange(Sender: TObject);
    procedure sbStatusClick(Sender: TObject);
    procedure btnReviewClick(Sender: TObject);
    procedure btnChangeClick(Sender: TObject);
    procedure ebShortChange(Sender: TObject);
    procedure btnBack1Click(Sender: TObject);
    procedure btnChange2Click(Sender: TObject);
    procedure lvMainDblClick(Sender: TObject);
    procedure lvMainInfoTip(Sender: TObject; Item: TListItem;
      var InfoTip: String);
    procedure lvMainMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure pnlReviewUndoMouseMove(Sender: TObject; Shift:
      TShiftState; X, Y: Integer);
    procedure btnAllClick(Sender: TObject);
    procedure btnNoneClick(Sender: TObject);
    procedure btnUndoClick(Sender: TObject);
    procedure btnNextClick(Sender: TObject);
    procedure btnPrevClick(Sender: TObject);
    procedure btnDelRecClick(Sender: TObject);
    procedure btnReportClick(Sender: TObject);
    procedure btnToMainClick(Sender: TObject);
    procedure wbReptNavigateComplete2(Sender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
    procedure btnBack2Click(Sender: TObject);
    procedure btnLaunchClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnAboutClick(Sender: TObject);
    procedure btnHelpClick(Sender: TObject);
    procedure SaveDialog1TypeChange(Sender: TObject);
  private
    { Private declarations }
    Busy       : Boolean; // if true, system is busy making changes
    FirstInfo  : Boolean; // if true, display first-time information
    UseShrt    : Boolean; // if true, use short filenames
    Warning    : Boolean; // if true, display first-change warning
    WarnDrive  : Boolean; // if true, display drive-order warning
    WarnStat   : Boolean; // if true, display yelllw-status warning
    ReptFormat : Integer; // 1 for TXT, 2 for HTM
    ckCount    : Integer; // number of checked items
    currUndo   : Integer; // number of current change record
    unCount    : Integer; // number of unchecked items
    descrip    : String;  // description of this change
    ininame    : String;  // name of INI file
    oldLong    : String;  // old address as long filename
    oldShrt    : String;  // old address as short filename
    newLong    : String;  // new address as long filename
    newShrt    : String;  // new address as short filename
    ReportName : String;  // name of report file
    ReptFolder : String;  // starting folder for reports
    undoBase   : String;  // base filename for change records
    bmpRed     : TBitmap; // red-light bitmap for status
    bmpYel     : TBitmap; // yellow-light bitmap for status
    bmpGrn     : TBitmap; // green-light bitmap for status
    ChgTime    : TDateTime;   // time the change operation began
    RegEqs     : TStringList; // list of Registry key equivalents
    wbRept     : TWebBrowser; // component created at run-time
    procedure AppActivate(Sender: TObject);
    procedure BuildDescripHint;
    procedure CheckNextPrev;
    procedure CheckStatus;
    function Exists(const S : String) : Boolean;
    procedure LoadUndo(which : Integer);
    function NextUndoNum : Integer;
    procedure SaveForUndo(const fName : String);
    procedure StartSearch;
    procedure ToggleItem(TL : TListItem);
    // procedures for communication from worker threads
    procedure AddIni(const cItem, cPath, cSub1, cSub2, cOld,
      cNew : String; vSubType, vData1, vHits, vCount,
      vStatus : Integer; vData2 : DWORD);
    procedure AddLnk(const cItem, cPath, cSub1, cSub2, cOld,
      cNew : String; vSubType, vData1, vHits, vCount,
      vStatus : Integer; vData2 : DWORD);
    procedure AddReg(const cItem, cPath, cSub1, cSub2, cOld,
      cNew : String; vSubType, vData1, vHits, vCount,
      vStatus : Integer; vData2 : DWORD);
    procedure ReportIni(I : Integer);
    procedure ReportLnk(I : Integer);
    procedure ReportReg(I : Integer);
    procedure DoneIni(Sender: TObject);
    procedure DoneLnk(Sender: TObject);
    procedure DoneReg(Sender: TObject);
    procedure FailBack(I, stat : Integer);
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation
uses shellapi, Inifiles, FileCtrl, AboutBox, allfuncs, coafuncs,
  CoaThds, Thd_Ini, Thd_Lnk, coaGenl, regequiv, Thd_Reg, warnu;
{$R *.DFM}
const
  nbpgMain = 0;
  nbpgShrt = 1;
  nbpgSrch = 2;
  nbpgFound = 3;
  nbpgRept = 4;

procedure TMainForm.AppActivate(Sender: TObject);
begin
  IF nbMain.PageIndex = 0 THEN
    begin
      WITH ebOldLong DO
        IF Exists(Text) THEN Font.Color := clBlue
        ELSE                 Font.Color := clWindowText;
      WITH ebNewLong DO
      IF Exists(Text) THEN Font.Color := clBlue
      ELSE                 Font.Color := clWindowText;
      CheckStatus;
    end;
end;

procedure TMainForm.FormActivate(Sender: TObject);
const first : Boolean = True;
begin
  // Set the focus to the old address box the first time the form
  // is activated (can't do it in OnCreate, because the control
  // has not been created yet)
  IF first THEN
    begin
      ebOldLong.SetFocus;
      first := False;
      IF FirstInfo THEN
        WITH TWarnForm.Create(Self) DO
        try
          SetData('COA2 is a "Change of Address" utility. You use i'+
            't to inform Windows of changes that you have made to y'+
            'our system. For example, if you move a folder from one'+
            ' location to another, COA2 will update all system refe'+
            'rences to that folder. If you add or remove a drive, c'+
            'ausing other drive letters to change, COA2 will fix th'+
            'e system references to programs on the changed drive.',
            'COA2 does NOT move files itself.',
            'Don''t tell me again', False);
          ShowModal;
          FirstInfo := NOT cbDont.checked;
        finally
          Free;
        end;
    end;
  IF nbMain.PageIndex = 0 THEN
    CheckStatus;
end;

procedure TMainForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  IF Busy THEN
    begin
      MessageBox(Handle, 'COA2 is busy locating system references t'+
        'o the old address and changing them so they refer to the n'+
        'ew. When the process is complete, you can review what was '+
        'changed, and you can undo changes.', 'COA2', MB_OK OR
        MB_ICONINFORMATION);
      CanClose := False
    end
  ELSE CanClose := True;
end;

procedure TMainForm.FormCreate(Sender: TObject);
VAR WindowsDrv : String;

  procedure InitGlyphs;
  VAR
    N : Integer;
    TB : TBitmap;
  begin
    btnBack1.Glyph.LoadFromResourceID(hInstance, 5);
    btnBack2.Glyph.LoadFromResourceID(hInstance, 5);
    btnLaunch.Glyph.LoadFromResourceID(hInstance, 6);
    btnReport.Glyph.LoadFromResourceID(hInstance, 7);
    btnChange.Glyph.LoadFromResourceID(hInstance, 8);
    btnChange2.Glyph.LoadFromResourceID(hInstance, 8);
    btnReview.Glyph.LoadFromResourceID(hInstance, 9);
    btnOldFold.Glyph.LoadFromResourceID(hInstance, 10);
    btnNewFold.Glyph.LoadFromResourceID(hInstance, 10);
    btnOldFile.Glyph.LoadFromResourceID(hInstance, 11);
    btnNewFile.Glyph.LoadFromResourceID(hInstance, 11);
    btnDn.Glyph.LoadFromResourceID(hInstance, 12);
    btnUp.Glyph.LoadFromResourceID(hInstance, 13);
    btnUndo.Glyph.LoadFromResourceID(hInstance, 14);
    btnNext.Glyph.LoadFromResourceID(hInstance, 15);
    btnPrev.Glyph.LoadFromResourceID(hInstance, 16);
    btnToMain.Glyph.LoadFromResourceID(hInstance, 17);
    btnDelRec.Glyph.LoadFromResourceID(hInstance, 18);
    TB := TBitmap.Create;
    try
      FOR N := 19 TO 22 DO
        begin
          TB.Handle := LoadImage(hInstance, MakeIntResource(N),
            IMAGE_BITMAP, 16, 16, lr_DefaultColor);
          ilTypes.AddMasked(TB, clFuchsia);
        end;
      ilChecks.Clear;
      FOR N := 23 TO 28 DO
        begin
          TB.Handle := LoadImage(hInstance, MakeIntResource(N),
            IMAGE_BITMAP, 16, 16, lr_DefaultColor);
          ilChecks.AddMasked(TB, clFuchsia);
        end;
    finally
      TB.Free;
    end;
  end;

  procedure InitVariables;
  VAR N : Integer;
  begin
    Busy := False;
    ininame  := ChangeFileExt(Application.Exename, '.INI');
    undobase := ExtractFileDir(Application.Exename) +
      '\UndoData.$$$.';
    WITH TIniFile.Create(ininame) DO
    try
      ReptFolder := ReadString('Settings', 'ReportFolder',
        ExtractFileDir(Application.Exename));
      ReptFormat := ReadInteger('Settings', 'ReportFormat', 1);
      Warning    := ReadBool('Settings', 'ChangeWarning', True);
      WarnDrive  := ReadBool('Settings', 'DriveWarning', True);
      WarnStat   := ReadBool('Settings', 'StatusWarning', True);
      FirstInfo  := ReadBool('Settings', 'FirstInfo', True);
    finally
      Free;
    end;
    currundo := 0;
    FOR N := cUndoMax DOWNTO 1 DO
      IF FileExists(undobase + IntToStr(N)) THEN
        begin
          currUndo := N;
          Break;
        end;
    SetLength(WindowsDrv, MAX_PATH);
    IF (GetWindowsDirectory(PChar(WindowsDrv), MAX_PATH) > 2) AND
      (GetLastError = 0) THEN
      SetLength(WindowsDrv, 3)
    ELSE WindowsDrv := 'C:\';
    bmpRed := TBitmap.Create;
    bmpYel := TBitmap.Create;
    bmpGrn := TBitmap.Create;
    bmpRed.LoadFromResourceID(hInstance, 3);
    bmpYel.LoadFromResourceID(hInstance, 2);
    bmpGrn.LoadFromResourceID(hInstance, 1);
  end;

  procedure InitRegEquivalents;
  VAR RKE : Integer;
  const
    ss : ARRAY[1..7] OF String = ('','','s','','s','s','s');
    hkhkcr = 'HKEY_CLASSES_ROOT';
    hkhkcu = 'HKEY_CURRENT_USER';
    hkhkcc = 'HKEY_CURRENT_CONFIG';
    hkNames : ARRAY[1..7] OF String = (
      hkhkcr, hkhkcu, hkhkcr + ' and ' + hkhkcu,
      hkhkcc, hkhkcr + ' and ' + hkhkcc,
      hkhkcu + ' and ' + hkhkcc,
      hkhkcr + ', ' + hkhkcu + ' and ' + hkhkcc);
  begin
    RegEqs := TStringList.Create;
    RKE := RootKeyEquivalents(RegEqs);
    IF RKE <> 0 THEN
      MessageBox(Handle, PChar(Format('COA2 was unable to correctly'+
        ' determine the equivalent%s for the Registry root key%s %s'+
        '.'#13#10#13#10'As a result, the reports may contain some d'+
        'uplicate elements.', [ss[RKE], ss[RKE], hknames[RKE]])),
        'COA2', MB_OK OR MB_ICONINFORMATION);
  end;

  procedure PlaceControlsForScale;
  // A number of COA2's controls either size automatically or
  // "stick" to the right-hand side by using the Anchors property.
  // Others use Align to fill all or part of their container.
  // These features can get thrown off by scaling for different
  // pixelsperinch, and by resizing the form in the OnCreate
  // handler. Here we make sure they all start out correctly.
  VAR W : Integer;
  begin
    Constraints.MinHeight := Height - ClientHeight + btnChange.Top +
      btnChange.Height + 6 + pnlButtons.Height + ebOldLong.Height;
    W := btnNext.Left + btnNext.Width + btnReport.Width + 24;
    IF W > 440 THEN
      Constraints.MinWidth := W
    ELSE Constraints.MinWidth := 440;
    // Set constraints first, becuase user-defined function
    // GetPosFmIni uses them as defaults.
    GetPosFmIni(ininame, Self, True);
    // Make sure containers have correct width
    nbMain.Width        := Self.ClientWidth;
    pnlReviewUndo.Width := nbMain.Width;
    pnlReptText.Width   := nbMain.Width;
    // Status bar height doesn't auto-adjust for Large Fonts
    sbMain.Height       := ebOldLong.Height - 2;
    // these 5 buttons "stick" to right edge
    btnDn.Left          := nbMain.Width - btnDn.Width - 8;
    btnUp.Left          := btnDn.Left;
    btnChange.Left      := nbMain.Width - btnChange.Width - 8;
    btnChange2.Left     := btnChange.Left;
    btnLaunch.Left      := btnChange.Left;
    // width of these edit boxes is relative to form width
    ebOldLong.Width     := btnDn.Left - ebOldLong.Left - 8;
    ebNewLong.Width     := ebOldLong.Width;
    ebDesc.Width        := nbMain.Width - ebDesc.Left - 8;
    ebStatus.Width      := ebDesc.Width;
    // Make sure the report button aligns with its two neighbors to
    // the left even when they've all been resized
    btnReport.Height    := btnPrev.Top + btnPrev.Height -
      btnReport.Top;
  end;

  procedure InitHtmlReptBrowser;
  begin
    try
      wbRept := TWebBrowser.Create(Self);
    except
      ON Exception DO
        wbRept := nil;
    end;
    IF wbRept <> nil THEN
      begin
        // Give the new control the same parent as lbRept
        lblRept.Parent.InsertControl(wbRept);
        // and discard lbRept
        lblRept.Free;
        wbRept.Align               := alClient;
        wbRept.OnNavigateComplete2 := wbReptNavigateComplete2;
        wbRept.Hint                := reRept.Hint;
      end
    ELSE
      lblRept.Caption := 'COA2 relies on the Internet Explorer Acti'+
        'veX control to provide a preview of its HTML report. This '+
        'control is installed along with IE4 or higher. If you woul'+
        'd like to use the HTML preview feature, please install IE4'+
        ' or higher. Click Launch to display the HTML report in you'+
        'r browser.';
  end;

  procedure InitProperties;
  begin
    WITH Application DO
      begin
        Helpfile := ChangeFileExt(Exename, '.HLP');
        OnActivate := AppActivate;
      end;
    nbMain.PageIndex    := nbpgMain;
    btnChange.Caption   := '&Change'#13#10'now';
    btnChange2.Caption  := '&Change'#13#10'now';
    btnReview.Caption   := '&Review'#13#10'past'#13#10'changes';
    btnReport.Caption   := '&Create'#13#10'detail'#13#10'report';
    AnChange.ResID            := 4;
    AnChange.Transparent      := True;
    reRept.Paragraph.TabCount := 3;
    reRept.Paragraph.Tab[0]   := 16;
    reRept.Paragraph.Tab[1]   := 32;
    reRept.Paragraph.Tab[2]   := 64;
    SaveDialog1.InitialDir    := ReptFolder;
    btnReview.Enabled         := currUndo <> 0;
    btnDelRec.Enabled         := currUndo <> 0;
    btnReport.Enabled         := currUndo <> 0;
    OpenDialog1.InitialDir    := WindowsDrv;
    sbStatus.Glyph            := bmpRed;
  end;

begin
  // TMainForm.FormCreate()
  InitGlyphs;
  InitVariables;
  InitRegEquivalents;
  PlaceControlsForScale;
  InitHtmlReptBrowser;
  InitProperties;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  RegEqs.Free;
  SetPosToIni(ininame, Self, True);
  WITH TIniFile.Create(Ininame) DO
  try
    WriteString ('Settings', 'ReportFolder',  ReptFolder);
    WriteInteger('Settings', 'ReportFormat',  ReptFormat);
    WriteBool   ('Settings', 'ChangeWarning', Warning);
    WriteBool   ('Settings', 'DriveWarning',  WarnDrive);
    WriteBool   ('Settings', 'StatusWarning', WarnStat);
    WriteBool   ('Settings', 'FirstInfo',     FirstInfo);
  finally
    Free;
  end;
end;

procedure TMainForm.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  IF Key = VK_F1 THEN
    Application.HelpContext(nbMain.PageIndex + 2);
end;

procedure TMainForm.nbMainMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
// This method exists to provide flyover help for disabled controls
// that are disabled
VAR
  P : TPoint;
  N : Integer;
  Page : TPage;
begin
  P := Point(X, Y);
  Page := nil;
  WITH (Sender AS TNotebook) DO
    begin
      FOR N := 0 TO ControlCount-1 DO
        IF Controls[N] IS TPage THEN
          IF TPage(Controls[N]).Visible THEN
            Page := TPage(Controls[N]);
      IF Page = nil THEN Exit;
      Hint := '';
      FOR N := 0 TO Page.ControlCount-1 DO
        IF Page.Controls[N] IS TWinControl THEN
          IF PtInRect(TWinControl(Page.Controls[N]).BoundsRect, P) THEN
            Hint := TWInControl(Page.Controls[N]).Hint;
      IF Hint = '' THEN
        Application.CancelHint;
    end;
end;

procedure TMainForm.btnOldFoldClick(Sender: TObject);
VAR S : String;
begin
  IF GetFolder(Handle, ebOldLong.Text, 'COA2 - get old drive/folder'+
    ' address', S) THEN
      ebOldLong.Text := S;
end;

procedure TMainForm.btnOldFileClick(Sender: TObject);
begin
  WITH OpenDialog1 DO
    begin
      Title := 'COA2 - get old filename address';
      IF NOT Execute THEN Exit;
      ebOldLong.Text := Filename;
    end;
end;

procedure TMainForm.ebOldLongChange(Sender: TObject);
begin
  WITH Sender AS TEdit DO
    begin
      IF Exists(Text) THEN Font.Color := clBlue
      ELSE                 Font.Color := clWindowText;
      btnDn.Enabled := Text <> '';
    end;
  CheckStatus;
end;

procedure TMainForm.btnDnClick(Sender: TObject);
begin
  ebNewLong.Text := ebOldLong.Text;
end;

procedure TMainForm.btnNewFoldClick(Sender: TObject);
VAR S : String;
begin
  IF GetFolder(Handle, ebOldLong.Text, 'COA2 - get new drive/folder'+
    ' address', S) THEN
      ebNewLong.Text := S;
end;

procedure TMainForm.btnNewFileClick(Sender: TObject);
begin
  WITH OpenDialog1 DO
    begin
      Title := 'COA2 - get new filename address';
      IF NOT Execute THEN Exit;
      ebNewLong.Text := Filename;
    end;
end;

procedure TMainForm.ebNewLongChange(Sender: TObject);
begin
  WITH Sender AS TEdit DO
    begin
      IF Exists(Text) THEN Font.Color := clBlue
      ELSE                 Font.Color := clWindowText;
      btnUp.Enabled := Text <> '';
    end;
  CheckStatus;
end;

procedure TMainForm.btnUpClick(Sender: TObject);
begin
  ebOldLong.Text := ebNewLong.Text;
end;

procedure TMainForm.btnDescClick(Sender: TObject);
// Auto-generate a description from the two names. If they're too
// long, use the Delphi MinimizeName function to shorten them.
VAR
  S   : String;
  Wid : Integer;
begin
  wid  := Canvas.TextWidth(StringOfChar('W', ebDesc.MaxLength));
  REPEAT
    S := Format('Change "%s" to "%s"',
      [MinimizeName(ebOldLong.Text, Canvas, Wid),
      MinimizeName(ebNewLong.Text, Canvas, Wid)]);
    Dec(Wid, 8);
  UNTIL Length(S) <= ebDesc.MaxLength;
  ebDesc.Text := S;
end;

procedure TMainForm.ebDescChange(Sender: TObject);
begin
  CheckStatus;
end;

procedure TMainForm.sbStatusClick(Sender: TObject);
begin
  Application.HelpCommand(HELP_CONTEXTPOPUP, sbStatus.Tag);
end;

procedure TMainForm.btnReviewClick(Sender: TObject);
begin
  LoadUndo(currUndo);
  nbMain.PageIndex := nbpgFound;
  CheckNextPrev;
end;

procedure TMainForm.btnChangeClick(Sender: TObject);
VAR
  S         : String;
  N         : Integer;
  CheckShrt : Boolean;
begin
  IF Warning THEN
    WITH TWarnForm.Create(Self) DO
    try
      SetData('COA2 will now change the old address to the new addr'+
        'ess in all shortcuts and INI files, and in non-binary port'+
        'ions of the Registry. When the process is complete, you wi'+
        'll have a chance to review the changes and undo any of the'+
        'm that you wish.', 'Proceed with change of address?',
        'Don''t ask me again', True);
      CASE ShowModal OF
        idYes : begin
          Warning := NOT cbDont.checked;
        end;
        ELSE Exit;
      END;
    finally
      Free;
    end;
  IF WarnDrive AND (length(ebNewLong.Text) <= 3) THEN
    WITH TWarnForm.Create(Self) DO
    try
      SetData('You have asked to change one drive letter to another'+
        '. If multiple drive letters must be changed, it is ESSENTI'+
        'AL that you make the changes in the correct order.'#13#10+
        #13#10'When changing two or more drives to a higher letter,'+
        ' you must start with the HIGHEST. For example, if you have'+
        ' added a new drive letter D:, so that the old D: becomes E'+
        ': and the old E: becomes F:, you must first change E: to F'+
        ': and then change D: to E:.'#13#10#13#10'When changing two'+
        ' or more drives to a lower letter, you must start with the'+
        ' LOWEST. For example, if you removed the drive letter D:, '+
        'so that the old E: becomes D: and the old F: becomes E:, y'+
        'ou must change E: to D: and then change F: to E:.',
        'Do you want to proceed?', 'Don''t ask me again', True);
      CASE ShowModal OF
        idYes : begin
          WarnDrive := NOT cbDont.checked;
        end;
        ELSE Exit;
      END;
    finally
      Free;
    end
  ELSE IF WarnStat AND (sbStatus.Tag > grnExistBoth) THEN
    WITH TWarnForm.Create(Self) DO
    try
      SetData('Note that the status line says "Warning" and the adj'+
        'acent button shows a yellow light. The old address is a va'+
        'lid file or folder name and the new address is an existing'+
        ' file or folder, but there is something about them that yo'+
        'u should consider carefully before continuing. Please clic'+
        'k the status button for a detailed explanation.',
        'Do you want to proceed?', 'Don''t ask me again', True);
      CASE ShowModal OF
        idYes : begin
          WarnStat := NOT cbDont.checked;
        end;
        ELSE Exit;
      END;
    finally
      Free;
    end;
  // Free the objects associated with listview items
  FOR N := lvMain.Items.Count-1 DOWNTO 0 DO
    WITH lvMain.Items[N] DO
      TChangeObj(Data).Free;
  // Clear the listview
  lvMain.Items.Clear;
  oldLong := ebOldLong.Text;
  oldShrt := GetShort(oldLong);
  newLong := ebNewLong.Text;
  newShrt := GetShort(newLong);
  IF ebDesc.Text = '' THEN
    btnDescClick(btnDesc);
  descrip := ebDesc.Text;
  pnlDesc.Caption := ' ' + descrip;
  CheckShrt := False;
  // Go to short filenames page if both don't exist...
  IF (oldShrt = '') AND (newShrt = '') THEN CheckShrt := True;
  // ... or if one doesn't exist and the other is not the same
  //     as the long filename
  IF (oldShrt <> '') AND (newShrt = '') AND
    (AnsiCompareText(oldLong, oldShrt) <> 0) THEN CheckShrt := True;
  IF (oldShrt = '') AND (newShrt <> '') AND
    (AnsiCompareText(newLong, newShrt) <> 0) THEN CheckShrt := True;
  IF CheckShrt THEN
    begin
      // Set up the fields on the short filenames page
      ebOldCopy.Width     := ebDesc.Width;
      ebOldShrt.Width     := ebDesc.Width;
      ebNewCopy.Width     := ebDesc.Width;
      ebNewShrt.Width     := ebDesc.Width;
      lblShort.Width      := ebDesc.Width;
      ebOldCopy.Text := ebOldLong.Text;
      ebNewCopy.Text := ebNewLong.Text;
      S := '';
      IF oldShrt = '' THEN
        begin
          ebOldShrt.ReadOnly := False;
          ebOldShrt.Color := clWindow;
          S := 'the old address';
        end;
      IF newShrt = '' THEN
        begin
          ebNewShrt.ReadOnly := False;
          ebNewShrt.Color := clWindow;
          IF S = '' THEN
            S := 'the new address'
          ELSE S := 'both addresses';
        end;
      ebOldShrt.Text := oldShrt;
      ebNewShrt.Text := newShrt;
      lblShort.Caption := 'COA2 is unable to determine the '+
        'correct short (8.3) filename for '+S+'. Please enter '+
        'the correct value or check the box below before proceeding.';
      // go to the short filenames page
      nbMain.PageIndex := nbpgShrt;
    end
  ELSE
    begin
      useShrt := (AnsiCompareText(oldLong, oldShrt) <> 0)
        OR (AnsiCompareText(newLong, newShrt) <> 0);
      StartSearch;
    end;
end;

procedure TMainForm.ebShortChange(Sender: TObject);
  function FormedOKS(const S: String): Boolean;
  VAR workS, partS, ExtS : String;
    P : Integer;
    function BadChars(const SS : String) : Boolean;
    VAR N : Integer;
    begin
      Result := False;
      FOR N := 1 TO Length(SS) DO
        CASE SS[N] OF
          '?','*','.','"','/','\','[',']',':',
          '|','<','>','+','=',';',',',' ' : begin
            Result := True;
            Break;
          end;
        END;
    end;
  begin
    CASE Length(S) OF
      0, 1 : Result := False;
      2 : Result := IsCharAlpha(S[1]) AND (S[2] = ':');
      ELSE Result := IsCharAlpha(S[1]) AND (S[2] = ':')
        AND (S[3] = '\');
    END;
    IF Result THEN
      begin
        Result := True;
        workS := S;
        WHILE True DO
          begin
            partS := ExtractFilename(WorkS);
            IF PartS = '' THEN break;
            WorkS := ExtractFileDir(WorkS);
            P := Pos('.', partS);
            IF P > 0 THEN
              begin
                extS := partS;
                system.delete(extS, 1, P);
                SetLength(partS, P-1);
              end
            ELSE ExtS := '';
            IF (Length(partS) > 8) OR (Length(extS) > 3) OR
              BadChars(partS) OR BadChars(extS) THEN
              begin
                Result := False;
                Exit;
              end;
          end;
      end
    ELSE Result := False;
  end;


begin
  IF cbNoShort.Checked THEN btnChange2.Enabled := True
  ELSE IF Exists(ebOldShrt.Text) THEN
    begin
      IF (Exists(ebNewShrt.Text) OR FormedOKS(ebNewShrt.Text)) AND
        SlashMatch(ebNewShrt.Text, ebNewCopy.Text) THEN
        btnChange2.Enabled := True
      ELSE btnChange2.Enabled := False
    end
  ELSE IF Exists(ebNewShrt.Text) THEN
    begin
      IF FormedOKS(ebOldShrt.Text) AND
        SlashMatch(ebOldShrt.Text, ebOldCopy.Text) THEN
        btnChange2.Enabled := True
      ELSE btnChange2.Enabled := False
    end
  ELSE btnChange2.Enabled := False;
end;

procedure TMainForm.btnBack1Click(Sender: TObject);
begin
  nbMain.PageIndex := nbpgMain;
  ebOldLong.SetFocus;
end;

procedure TMainForm.btnChange2Click(Sender: TObject);
begin
  oldShrt := ebOldShrt.Text;
  newShrt := ebNewShrt.Text;
  useShrt := (NOT cbNoShort.Checked) AND
    ((AnsiCompareText(oldLong, oldShrt) <> 0) OR
     (AnsiCompareText(newLong, newShrt) <> 0));
  StartSearch;
end;

procedure TMainForm.lvMainDblClick(Sender: TObject);
begin
  WITH Sender AS TListView DO
    IF Selected <> nil THEN
      ToggleItem(Selected);
end;

procedure TMainForm.lvMainInfoTip(Sender: TObject; Item: TListItem;
  var InfoTip: String);
begin
  WITH Item DO
    WITH TChangeObj(Data) DO
      InfoTip := Hint;
end;

procedure TMainForm.lvMainMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  IF Button = mbLeft THEN
    WITH Sender AS TListView DO
      IF htOnStateIcon IN GetHitTestInfoAt(X, Y) THEN
        ToggleItem(GetItemAt(X,Y));
end;

procedure TMainForm.pnlReviewUndoMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
// This method exists to provide flyover help for controls
// that are disabled
VAR
  P : TPoint;
  N : Integer;
begin
  P := Point(X, Y);
  WITH Sender AS TWinControl DO
    begin
      Hint := '';
      FOR N := 0 TO ControlCount-1 DO
        IF Controls[N] IS TWinControl THEN
          IF PtInRect(TWinControl(Controls[N]).BoundsRect, P) THEN
            Hint := TWInControl(Controls[N]).Hint;
      IF Hint = '' THEN
        Application.CancelHint;
    end;
end;

procedure TMainForm.btnAllClick(Sender: TObject);
VAR N : Integer;
begin
  ckCount := 0;
  unCount := 0;
  FOR N := 0 TO lvMain.Items.Count-1 DO
    WITH lvMain.Items[N] DO
      IF StateIndex IN [statBlank, statCheck] THEN
        begin
          StateIndex := statCheck;
          Inc(ckCount);
        end;
  btnUndo.Enabled := (ckCount > 0);
end;

procedure TMainForm.btnNoneClick(Sender: TObject);
VAR N : Integer;
begin
  ckCount := 0;
  unCount := 0;
  FOR N := 0 TO lvMain.Items.Count-1 DO
    WITH lvMain.Items[N] DO
      IF StateIndex IN [statBlank, statCheck] THEN
        begin
          StateIndex := statBlank;
          Inc(unCount);
        end;
  btnUndo.Enabled := False;
end;

procedure TMainForm.btnUndoClick(Sender: TObject);
VAR N : Integer;
begin
  IF btnNext.Enabled THEN
    IF MessageBox(Handle, 'This is not the most recent change recor'+
      'd. If items recorded in this change record were modified aga'+
      'in by a later session with COA2, it may not be possible to u'+
      'ndo them.'#13#10#13#10'Proceed anyway?', 'COA2',
      MB_YESNO OR MB_ICONQUESTION) <> idYes THEN
        Exit;
  IF NOT Exists(OldLong) THEN
    IF MessageBox(Handle, PChar(Format('The old address "%s" does'+
      ' not represent an existing file or folder. An attempt to u'+
      'ndo a change to a shortcut''s target involving this addres'+
      's will fail.'#13#10#13#10'Proceed anyway?', [OldLong])),
      'COA2', MB_YESNO OR MB_ICONQUESTION) <> idYes THEN
        Exit;
  FOR N := lvMain.Items.Count-1 DOWNTO 0 DO
    WITH lvMain.Items[N] DO
      IF StateIndex = statCheck THEN
        begin
          Dec(ckCount);
          WITH TChangeObj(Data) DO
            IF Undo THEN
              StateIndex := 3
            ELSE
              StateIndex := 2;
        end;
  btnUndo.Enabled := False;
  ckCount := 0;
  // Save the latest change record
  SaveForUndo(undobase+IntToStr(currUndo));
  btnAll.Enabled  := unCount+ckCount > 0;
  btnNone.Enabled := unCount+ckCount > 0;
end;

procedure TMainForm.btnNextClick(Sender: TObject);
VAR
  N        : Integer;
  nextUndo : Integer;
begin
  nextUndo := 0;
  FOR N := currUndo+1 TO cUndoMax DO
    IF FileExists(undobase + IntToStr(N)) THEN
      begin
        nextUndo := N;
        Break;
      end;
  IF nextUndo = 0 THEN
    begin
      MessageBox(Handle, 'COA2 cannot display the requested change '+
        'record, because it was deleted by another program', 'COA2',
        MB_OK OR MB_ICONINFORMATION);
    end
  ELSE
    begin
      SaveForUndo(undobase + IntToStr(currUndo));
      currUndo := NextUndo;
      loadUndo(currUndo);
      btnUndo.Enabled := ckCount > 0;
    end;
  CheckNextPrev;
end;

procedure TMainForm.btnPrevClick(Sender: TObject);
VAR
  N        : Integer;
  nextUndo : Integer;
begin
  nextUndo := 0;
  FOR N := currUndo-1 DOWNTO 1 DO
    IF FileExists(undobase + IntToStr(N)) THEN
      begin
        nextUndo := N;
        Break;
      end;
  IF nextUndo = 0 THEN
    begin
      MessageBox(Handle, 'COA2 cannot display the requested change '+
        'record, because it was deleted by another program', 'COA2',
        MB_OK OR MB_ICONINFORMATION);
    end
  ELSE
    begin
      SaveForUndo(undobase + IntToStr(currUndo));
      currUndo := NextUndo;
      loadUndo(currUndo);
      btnUndo.Enabled := ckCount > 0;
    end;
  CheckNextPrev;
end;

procedure TMainForm.btnDelRecClick(Sender: TObject);
const has : array[Boolean] OF String = (' has', 's have');
VAR
  N         : Integer;
  numUndone : Integer;
  numRemain : Integer;
begin
  numRemain := UnCount + CkCount;
  numUndone := 0;
  FOR N := 0 TO lvMain.Items.Count-1 DO
    WITH lvMain.Items[N] DO
      WITH TChangeObj(Data) DO
        CASE UndoStatus OF
          statUndoX,
          statUndOK : Inc(NumUndone);
        END;
  IF (numRemain > 0) AND (numUndone > 0) THEN
    IF MessageBox(Handle, PChar(Format('This change record has been'+
      ' partially undone - %d item%s been undone and %d could still'+
      ' be undone.'#13#10#13#10'Are you sure you want to delete it?',
      [numUndone, has[numUndone > 1], numRemain])),
      'COA2', MB_YESNO OR MB_ICONQUESTION) <> idYes THEN
        Exit;
  FOR N := lvMain.Items.Count-1 DOWNTO 0 DO
    WITH lvMain.Items[N] DO
      TChangeObj(Data).Free;
  lvMain.Items.Clear;
  ckCount := 0;
  unCount := 0;
  DeleteFile(undobase+IntToStr(currUndo));
  currundo := 0;
  FOR N := cUndoMax DOWNTO 1 DO
    IF FileExists(undobase + IntToStr(N)) THEN
      begin
        currUndo := N;
        Break;
      end;
  pnlDesc.Caption := '';
  IF currUndo <> 0 THEN
    LoadUndo(currUndo)
  ELSE
    begin
      btnDelRec.Enabled := False;
      btnReport.Enabled := False;
    end;
  CheckNextPrev;
end;

procedure TMainForm.btnReportClick(Sender: TObject);
CONST Exts : String = ':.TXT:.HTM:.HTML:';
VAR Ext : String;
  procedure DoTextReport(const S : String);
  VAR
    T : TextFile;
    N : Integer;
    MainS : String;

    procedure TextHeader;
    begin
      WriteLn(T, 'COA2 Change record detail report');
      WriteLn(T);
      WriteLn(T, 'Description:'#9, descrip);
      WriteLn(T, 'Changed on:'#9, FormatDateTime('mmm d, yyyy, hh:mm:ss', ChgTime));
      WriteLn(T, StringOfChar('-', 60));
      WriteLn(T, #9'From:'#9+oldLong);
      WriteLn(T, #9'To:'#9+newLong);
      IF oldShrt <> '' THEN
        begin
          WriteLn(T, #9'From:'#9+oldShrt);
          WriteLn(T, #9'To:'#9+newShrt);
        end;
      WriteLn(T, StringOfChar('=', 60));
    end;

    procedure TextFooter;
    begin
      WriteLn(T);
      WriteLn(T, StringOfChar('=', 60));
      Write(T, #9'COA2, Copyright  2001 ');
      WriteLn(T, 'by Ziff Davis Media, Inc.');
      WriteLn(T, #9'Written by Neil J. Rubenking');
      Write  (T, #9'First published in PC Magazine, ');
      WriteLn(T, 'March 26, 2001.');
    end;
  begin
    ReptFormat := 1;
    ReportName := S;
    DeleteFile(S);
    AssignFile(T, S);
    Rewrite(T);
    try
      TextHeader;
      MainS := '';
      FOR N := 0 TO lvMain.Items.Count-1 DO
        WITH lvMain.Items[N] DO
          WITH TChangeObj(Data) DO
            ReportText(T, MainS);
      TextFooter;
    finally
      CloseFile(T);
    end;
    reRept.Lines.LoadFromFile(S);
    nbRept.PageIndex := 0;
    nbMain.PageIndex := nbpgRept;
  end;

  procedure DoHTMLReport(const S : String);
  VAR
    T : TextFile;
    N : Integer;
    MainS : String;
    procedure HTMLHeader;
    begin
      WriteLn(T, '<HTML><HEAD><TITLE>COA2 Change record detail report</TITLE></HEAD>');
      WriteLn(T, '<BODY><H1>COA2 Change record detail report</H1>');
      WriteLn(T, '<H2>Description: ', descrip, '<BR>');
      WriteLn(T, 'Changed on: ', FormatDateTime('mmm d, yyyy, hh:mm:ss', ChgTime), '</H2>');
      WriteLn(T, '<HR SIZE="3">');
      WriteLn(T, '<H3>From: '+oldLong, '<BR>');
      WriteLn(T, 'To: '+newLong, '<BR>');
      IF oldShrt <> '' THEN
        begin
          WriteLn(T, 'From: '+oldShrt, '<BR>');
          WriteLn(T, 'To: '+newShrt, '<BR>');
        end;
      WriteLn(T, '</H3><HR SIZE="3">');
    end;

    procedure HTMLFooter;
    begin
      WriteLn(T, '</H3><HR SIZE="3">');
      WriteLn(T, '<P><FONT SIZE="2">');
      WriteLn(T, 'COA2, Copyright &copy;&nbsp;2001 ');
      WriteLn(T, 'by Ziff Davis Media, Inc.<BR> </FONT>');
      WriteLn(T, '<FONT SIZE="1">Written by Neil J. Rubenking<BR>');
      Write  (T, 'First published in PC Magazine, ');
      WriteLn(T, 'March 26, 2001.');
      WriteLn(T, '</FONT> </P> <P></P> </BODY> </HTML>');
    end;

  begin
    ReptFormat := 2;
    ReportName := S;
    DeleteFile(S);
    AssignFile(T, S);
    Rewrite(T);
    try
      HTMLHeader;
      MainS := '';
      FOR N := 0 TO lvMain.Items.Count-1 DO
        WITH lvMain.Items[N] DO
          WITH TChangeObj(Data) DO
            ReportHTML(T, MainS);
      HTMLFooter;
    finally
      CloseFile(T);
    end;
    IF wbRept <> nil THEN
      wbRept.Navigate('file://'+ReportName)
    ELSE
      begin
        nbRept.PageIndex := 1;
        nbMain.PageIndex := nbpgRept;
      end;
  end;


begin
  WITH SaveDialog1 DO
    begin
      FilterIndex := ReptFormat;
      IF FilterIndex = 1 THEN
        DefaultExt := '.TXT'
      ELSE
        DefaultExt := '.HTM';
      IF Execute THEN
        begin
          ReptFolder := ExtractFileDir(Filename);
          Ext := Uppercase(ExtractFileExt(Filename));
          CASE Pos(Ext, Exts) OF
            2 : DoTextReport(Filename);
            7, 12 : DoHTMLReport(Filename);
            ELSE MessageBox(Handle, PChar(Format('The file extensio'+
              'n "%s" is not accepted for a COA2 detail report. The'+
              ' extension must be .TXT, .HTM, or .HTML.', [Ext])),
              'COA2', MB_OK OR MB_ICONSTOP);
          END;
        end;
    end;
end;

procedure TMainForm.btnToMainClick(Sender: TObject);
begin
  pnlLnkSearched.Caption := '0  ';
  pnlLnkFound.Caption    := '0  ';
  pnlIniSearched.Caption := '0  ';
  pnlIniFound.Caption    := '0  ';
  pnlRegSearched.Caption := '0  ';
  pnlRegFound.Caption    := '0  ';
  nbMain.PageIndex       := nbpgmain;
  ebOldLong.SetFocus;
end;

procedure TMainForm.wbReptNavigateComplete2(Sender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
begin
  nbRept.PageIndex := 1;
  nbMain.PageIndex := nbpgRept;
end;

procedure TMainForm.btnBack2Click(Sender: TObject);
begin
  nbMain.PageIndex := nbpgFound;
end;

procedure TMainForm.btnLaunchClick(Sender: TObject);
begin
  IF ShellExecute(Self.Handle, nil, PChar(REportName), nil,
    PChar(ExtractFileDir(ReportName)), SW_SHOW) < 32 THEN
    MessageBox(Handle, PChar(Format('Error %d ("%s") attempting to '+
      'launch this file:'#13#10#13#10'"%s".'#13#10#13#10'Please loa'+
      'd this file into the appropriate application.', [GetLastError,
      SysErrorMessage(GetLastError), ReportName])), 'COA2', MB_OK OR
      MB_ICONSTOP);
end;

procedure TMainForm.btnCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.btnAboutClick(Sender: TObject);
begin
  WITH TAboutForm.Create(Self) DO
  try
    ShowModal;
  finally
    Free;
  end;
end;

procedure TMainForm.btnHelpClick(Sender: TObject);
begin
  Application.HelpCommand(HELP_FINDER, 0);
end;

procedure TMainForm.SaveDialog1TypeChange(Sender: TObject);
begin
  WITH Sender AS TSaveDialog DO
    CASE FilterIndex OF
      1 :  DefaultExt := '.TXT';
      2 :  DefaultExt := '.HTM';
      ELSE DefaultExt := '.';
    END;
end;

procedure TMainForm.BuildDescripHint;
// Build an infotip and status line hint for the change record
// description
begin
  pnlDesc.Hint := descrip + #13#10 +
    FormatDateTime('mmm d, yyyy, hh:mm:ss', ChgTime) + #13#10 +
    'From: '+oldLong + #13#10 +
    '  To: '+newLong;
  IF oldShrt <> '' THEN
    pnlDesc.Hint := pnlDesc.Hint + #13#10 +
      'From: '+oldShrt + #13#10 +
      '  To: '+newShrt;
  pnlDesc.Hint := pnlDesc.Hint + '|' + descrip;
end;

procedure TMainForm.CheckNextPrev;
// Check whether to enable the next and previous record buttons
// Also set the caption for the "N of M" label
VAR
  N       : Integer;
  CanDo   : Boolean;
  ofOne   : Integer;
  ofCount : Integer;
begin
  CanDo := False;
  FOR N := currUndo-1 DOWNTO 1 DO
    IF FileExists(undobase+IntToStr(N)) THEN
      begin
        CanDo := True;
        Break;
      end;
  btnPrev.Enabled := CanDo;
  CanDo           := False;
  FOR N := currUndo+1 TO cUndoMax DO
    IF FileExists(undobase+IntToStr(N)) THEN
      begin
        CanDo := True;
        Break;
      end;
  btnNext.Enabled := CanDo;
  ofOne   := 0;
  ofCount := 0;
  FOR N := 1 TO cUndoMax DO
    begin
      IF FileExists(undobase+IntToStr(N)) THEN
        begin
          Inc(ofCount);
          IF N <= currUndo THEN
            Inc(Ofone);
        end;
    end;
  btnReview.Enabled := ofCount > 0;
  btnDelRec.Enabled := ofCount > 0;
  btnReport.Enabled := ofCount > 0;
  IF ofCount = 0 THEN
    pnlRecNum.Caption := ' (none)'
  ELSE pnlRecNum.Caption := Format('%d of %d', [Ofone, ofCount]);
end;

procedure TMainForm.CheckStatus;
// Go through a number of tests to identify the status of the old and
// new addresses. Report status of "Ready", "Warning" or "Not ready".
// Assign a more detailed status number to the Tag field of the
// sbstatus button (this number is the help context of a popup that
// explains the particular status)
VAR
  S2       : String;
  StatS    : Integer;
  oldSlash : Boolean;
  newSlash : Boolean;
const
  StatStr : ARRAY[1..3] OF String = ('Ready', 'Warning', 'Not ready');

  function FormedOK(const S : String) : Boolean;
    function BadChars(const SS : String) : Boolean;
    VAR N : Integer;
    begin
      Result := False;
      FOR N := 3 TO Length(SS) DO
        IF SS[N] = ':' THEN
          begin
            Result := True;
            Break;
          end;
      IF NOT Result THEN
        FOR N := 1 TO Length(SS) DO
          CASE SS[N] OF
            '?','*','"','/' : begin
              Result := True;
              Break;
            end;
          END;
    end;
  begin
    CASE Length(S) OF
      0, 1 : Result := False;
      2    : Result := IsCharAlpha(S[1]) AND (S[2] = ':');
      ELSE   Result := IsCharAlpha(S[1]) AND (S[2] = ':')
               AND (S[3] = '\') AND (NOT BadChars(S));
    END;
  end;

begin
  IF (ebOldLong.Text = '') THEN
    begin
      StatS := 3;
      IF ebNewLong.Text = '' THEN
        begin
          S2 := 'Both addresses are blank';
          sbStatus.Tag := redBlankBoth;
        end
      ELSE
        begin
          S2 := 'Old address is blank';
          sbStatus.Tag := redBlankOld;
        end;
    end
  ELSE IF (ebNewLong.Text = '') THEN
    begin
      StatS := 3;
      S2 := 'New address is blank';
      sbStatus.Tag := redBlankNew;
    end
  ELSE IF NOT FormedOK(ebOldLong.Text) THEN
    begin
      StatS := 3;
      IF NOT FormedOK(ebNewLong.Text) THEN
        begin
          S2 := 'Neither address is a valid filename';
          sbStatus.Tag := redInvalidBoth;
        end
      ELSE
        begin
          S2 := 'Old address is not a valid filename';
          sbStatus.Tag := redInvalidOld;
        end;
    end
  ELSE IF NOT FormedOK(ebNewLong.Text) THEN
    begin
      StatS := 3;
      S2 := 'New address is not a valid filename';
      sbStatus.Tag := redInvalidNew;
    end
  ELSE IF NOT Exists(ebOldLong.Text) THEN
    begin
      IF NOT Exists(ebNewLong.Text) THEN
        begin
          StatS := 3;
          S2 := 'Neither address exists';
          sbStatus.Tag := redNoExistBoth;
        end
      ELSE
        begin
          StatS := 1;
          S2 := 'New address exists';
          sbStatus.Tag := grnExistNew;
        end;
    end
  ELSE IF NOT Exists(ebNewLong.Text) THEN
    begin
      StatS := 3;
      S2 := 'New address does not exist';
      sbStatus.Tag := redInvalidNew;
    end
  ELSE IF ebOldLong.Text = ebNewLong.Text THEN
    begin
      StatS := 2;
      S2 := 'Addresses exist, but are identical';
      sbStatus.Tag := yelIdentical;
    end
  ELSE IF AnsiCompareText(ebOldLong.Text, ebNewLong.Text) = 0 THEN
    begin
      StatS := 2;
      S2 := 'Addresses exist, but are identical except for case';
      sbStatus.Tag := yelIdentiCase;
    end
  ELSE
    begin
      IF DirectoryExists(ebOldLong.Text) AND
        FileExists(ebNewLong.Text) THEN
        begin
          StatS := 2;
          S2 := 'Old address is folder, new is file';
          sbStatus.Tag := yelOldFoldNewFile;
        end
      ELSE IF DirectoryExists(ebNewLong.Text) AND
        FileExists(ebOldLong.Text) THEN
        begin
          StatS := 2;
          S2 := 'Old address is file, new is folder';
          sbStatus.Tag := yelOldFileNewFold;
        end
      ELSE
        begin
          StatS := 1;
          S2 := 'Both addresses exist';
          sbStatus.Tag := grnExistBoth;
        end;
    end;
  IF StatS <> 3 THEN
    begin
      IF (Length(ebOldLong.Text) <= 3) AND
        (Length(ebNewLong.Text) > 3) THEN
        begin
          StatS := 2;
          S2 := 'Old address is drive letter, new is not';
          sbStatus.Tag := yelOldDriveNewNot;
        end
      ELSE IF (Length(ebNewLong.Text) <= 3) AND
        (Length(ebOldLong.Text) > 3) THEN
        begin
          StatS := 2;
          S2 := 'New address is drive letter, old is not';
          sbStatus.Tag := yelNewDriveOldNot;
        end
      ELSE
        begin
          oldSlash := HasSlash(ebOldLong.Text);
          newSlash := HasSlash(ebNewLong.Text);
          IF oldSlash XOR newSlash THEN
            begin
              StatS := 2;
              IF oldSlash THEN
                begin
                  CASE sbStatus.Tag OF
                    grnExistNew       : begin
                      sbStatus.Tag := yelOldSlashExNew;
                      S2 := 'Old address ends with slash, new does '+
                        'not';
                    end;
                    yelOldFoldNewFile : ;
                    yelOldFileNewFold : ;
                    ELSE begin
                      sbStatus.Tag := yelOldSlashExBoth;
                      S2 := 'Old address ends with slash, new does '+
                        'not';
                    end;
                  end;
                end
              ELSE
                begin
                  CASE sbStatus.Tag OF
                    grnExistNew       : begin
                      sbStatus.Tag := yelNewSlashExNew;
                      S2 := 'New address ends with slash, old does '+
                        'not';
                    end;
                    yelOldFoldNewFile : ;
                    yelOldFileNewFold : ;
                    ELSE begin
                      sbStatus.Tag := yelNewSlashExBoth;
                      S2 := 'New address ends with slash, old does '+
                        'not';
                    end;
                  end;
                end;
            end
          ELSE IF DirectoryExists(ebNewLong.Text) AND
            (NOT newSlash) THEN
            begin
              StatS := 2;
                  CASE sbStatus.Tag OF
                    grnExistNew       : begin
                      sbStatus.Tag := yelFoldNoSlashExNew;
                      S2 := 'New address is folder but does not end'+
                        ' with slash';
                    end;
                    yelOldFoldNewFile : ;
                    yelOldFileNewFold : ;
                    ELSE begin
                      sbStatus.Tag := yelFoldNoSlashExBoth;
                      S2 := 'New address is folder but does not end'+
                        ' with slash';
                    end;
                  end;
            end;
        end;
    end;
  CASE statS OF
    1 : sbStatus.Glyph := bmpGrn;
    2 : sbStatus.Glyph := bmpYel;
    3 : sbStatus.Glyph := bmpRed;
  END;
  btnChange.Enabled := StatS <> 3;
  ebStatus.Text := StatStr[StatS] + ' - ' + S2;
end;

function TMainForm.Exists(Const S : String) : Boolean;
begin
  Result := DirectoryExists(S) OR FileExists(S);
end;

procedure TMainForm.LoadUndo(which : Integer);
// Read a change record using Delphi's TSTream objects
VAR
  Stream : TFileStream;
  Reader : TReader;
  N      : Integer;
  S      : String;
  B      : Byte;
  TCO    : TChangeObj;
begin
  // Free the change items
  FOR N := lvMain.Items.Count-1 DOWNTO 0 DO
    WITH lvMain.Items[N] DO
      TChangeObj(Data).Free;
  // Clear the list of change items
  lvMain.Items.Clear;
  unCount := 0;
  ckCount := 0;
  Stream := TFileStream.Create(undobase+IntTOStr(which), fmopenRead);
  try
    // Read the header information
    Reader := TReader.Create(Stream, 4096);
    try
      S := Reader.ReadString;
      IF S <> 'COA2UNDO' THEN
        Raise(Exception.Create('Not a valid COA2 change record'));
      descrip := Reader.ReadString;
      ChgTime := Reader.ReadDate;
      oldLong := Reader.ReadString;
      newLong := Reader.ReadString;
      oldShrt := Reader.ReadString;
      newShrt := Reader.ReadString;
      BuildDescripHint;
    finally
      Reader.Free;
    end;
    pnlDesc.Caption := ' ' + descrip;
    // Read the individual change items
    WHILE Stream.Position < Stream.Size DO
      begin
        Stream.Read(B, 1);
        CASE B OF
          1 : TCO := TChangeIniObj.CreateForStream;
          2 : TCO := TChangeLnkObj.CreateForStream;
          3 : TCO := TChangeRegObj.CreateForStream;
          ELSE TCO := nil; // Shouldn't happen; will cause exception
        END;
        TCO.LoadFromStream(Stream);
        WITH lvMain.Items.Add DO
          begin
            Data := TCO;
            IF B = 3 THEN
              Caption := TCO.Sub1
            ELSE
              Caption := TCO.ItmS;
            SubItems.Add(TCO.OldS);
            SubItems.Add(TCO.NewS);
            ImageIndex := B;
            StateIndex := TCO.UndoStatus;
            CASE StateIndex OF
              0 : Inc(UnCount);
              1 : Inc(CkCount);
            END;
          end;
      end;
  finally
    Stream.Free;
  end;
  btnAll.Enabled  := unCount+ckCount > 0;
  btnNone.Enabled := unCount+ckCount > 0;
end;

function TMainForm.NextUndoNum : Integer;
// Get the next available number for a change record file. If
// necessary, delete the oldest and move the others down
VAR
  Count : Integer;
  N     : Integer;
  names : ARRAY[1..cUndoMax] OF Integer;
begin
  count := 0;
  FOR N := 1 TO cUndoMax DO
    IF FileExists(undobase + IntToStr(N)) THEN
      begin
        Inc(Count);
        Names[Count] := N;
      end;
  IF Count = cUndoMax THEN
    begin
      DeleteFile(undobase+'1');
      FOR N := 1 TO cUndoMax-1 DO Names[N] := N+1;
      Count := cUndoMax-1;
    end;
  FOR N := 1 TO Count DO
    IF Names[N] <> N THEN
      RenameFile(undobase + IntToStr(Names[N]),
        undobase + IntToStr(N));
  Result := Count+1;
end;

procedure TMainForm.SaveForUndo(const fName : String);
// Save the change record to a file
VAR
  N      : Integer;
  Stream : TFileStream;
  Writer : TWriter;
  TCO    : TChangeObj;
  B      : Byte;
begin
  Stream := TFileStream.Create(fName, fmCreate);
  try
    // Write the header information
    Writer := TWriter.Create(Stream, 4096);
    try
      Writer.WriteString('COA2UNDO');
      Writer.WriteString(descrip);
      Writer.WriteDate(ChgTime);
      Writer.WriteString(oldLong);
      Writer.WriteString(newLong);
      Writer.WriteString(oldShrt);
      Writer.WriteString(newShrt);
      BuildDescripHint;
    finally
      Writer.Free;
    end;
    // Write the individual change items
    FOR N := 0 TO lvMain.Items.Count-1 DO
      begin
        TCO := TCHangeObj(lvMain.Items[N].Data);
        IF TCO IS TChangeIniObj THEN
          B := 1
        ELSE IF TCO IS TChangeLnkObj THEN
          B := 2
        ELSE IF TCO IS TChangeRegObj THEN
          B := 3
        ELSE Raise(Exception.Create('COA2 - internal data error'));
        Stream.Write(B, 1);
        TCO.SaveToStream(STream);
      end;
  finally
    Stream.Free;
  end;
end;

procedure TMainForm.StartSearch;
// Set the cursor to an hourglass, make the Changing addresses page
// visible, record the start time, and launch the thread that
// changes shortcuts. When that thread finishes, control goes to
// the DoneLnk method.
begin
  Screen.Cursor    := crHourglass;
  anChange.Active  := True;
  nbMain.PageIndex := nbpgSrch;
  Busy             := True;
  ckCount          := 0;
  unCount          := 0;
  IF NOT UseShrt THEN
    begin
      oldShrt := '';
      newShrt := '';
    end;
  ChgTime := Now;
  WITH TSearchLnkThread.Create(oldLong, oldShrt, newLong, newShrt,
    'LNK', AddLnk, ReportLnk, FailBack) DO
    begin
      OnTerminate := DoneLnk;
      Resume;
    end;
end;

procedure TMainForm.ToggleItem(TL: TListItem);
begin
  WITH TL DO
    CASE StateIndex OF
      0 : begin
        // If the item is un-checked, check it, increment the checked
        // count, and decrement the unchecked count
        StateIndex := 1;
        Inc(ckCount);
        Dec(unCount);
      end;
      1 : begin
        // If the item is checked, un-check it, increment the unchecked
        // count, and decrement the checked count
        StateIndex := 0;
        Dec(ckCount);
        Inc(unCount);
      end;
    END;
  btnUndo.Enabled := ckCount > 0;
end;

procedure TMainForm.AddIni(const cItem, cPath, cSub1, cSub2, cOld,
  cNew : String; vSubType, vData1, vHits, vCount, vStatus: Integer;
  vData2 : DWORD);
// Called by the INI-processing thread to add an item to the list
begin
  pnlIniFound.Caption    := FormatFloat('0,"  "', vHits);
  pnlIniSearched.Caption := FormatFloat('0,"  "', vCount);
  WITH lvMain.Items.Add DO
    begin
      Caption := cItem;
      SubItems.Add(cOld);
      SubItems.Add(cNew);
      StateIndex := vStatus AND $F;
      IF StateIndex = statBlank THEN
        Inc(UnCount);
      ImageIndex := 1;
      Data := TChangeIniObj.Create(vSubType, vData1, vData2,
        vStatus, cPath, cItem, cSub1, cSub2, cOld, cNew);
    end;
end;

procedure TMainForm.AddLnk(const cItem, cPath, cSub1, cSub2, cOld,
  cNew : String; vSubType, vData1, vHits, vCount, vStatus: Integer;
  vData2 : DWORD);
// Called by the shortcut-processing thread to add an item to the list
begin
  pnlLnkFound.Caption    := FormatFloat('0,"  "', vHits);
  pnlLnkSearched.Caption := FormatFloat('0,"  "', vCount);
  WITH lvMain.Items.Add DO
    begin
      Caption := cItem;
      SubItems.Add(cOld);
      SubItems.Add(cNew);
      ImageIndex := 2;
      StateIndex := vStatus AND $F;
      IF StateIndex = statBlank THEN
        Inc(UnCount);
      Data := TChangeLnkObj.Create(vSubType, vData1, vData2,
        vStatus, cPath, cItem, cSub1, cSub2, cOld, cNew);
    end;
end;

procedure TMainForm.AddReg(const cItem, cPath, cSub1, cSub2, cOld,
  cNew: String; vSubType, vData1, vHits, vCount, vStatus: Integer;
  vData2 : DWORD);
// Called by the Registry-processing thread to add an item to the list
begin
  pnlRegFound.Caption    := FormatFloat('0,"  "', vHits);
  pnlRegSearched.Caption := FormatFloat('0,"  "', vCount);
  WITH lvMain.Items.Add DO
    begin
      Caption := cSub1;
      SubItems.Add(cOld);
      SubItems.Add(cNew);
      StateIndex := vStatus AND $F;
      IF StateIndex = statBlank THEN
        Inc(UnCount);
      ImageIndex := 3;
      Data := TChangeRegObj.Create(vSubType, vData1, vData2, vStatus, cPath, cItem, cSub1, cSub2,
        cOld, cNew);
    end;
end;

procedure TMainForm.ReportIni(I: Integer);
begin
  pnlIniSearched.Caption := FormatFloat('0,"  "', I);
end;

procedure TMainForm.ReportLnk(I: Integer);
begin
  pnlLnkSearched.Caption := FormatFloat('0,"  "', I);
end;

procedure TMainForm.ReportReg(I: Integer);
begin
  pnlRegSearched.Caption := FormatFloat('0,"  "', I);
end;

procedure TMainForm.DoneIni(Sender: TObject);
// The INI-processing thread is finished - launch the Registry
// processing thread. When it is complete, control transfers
// to the DoneReg method
begin
  WITH TSearchRegThread.Create(oldLong, oldShrt, newLong, newShrt,
    AddReg, ReportReg, RegEqs, FailBack) DO
    begin
      OnTerminate := DoneReg;
      Resume;
    end;
end;

procedure TMainForm.DoneLnk(Sender: TObject);
// The shortcut-processing thread is finished - launch the INI-
// processing thread. When it is complete, control transfers
// to the DoneIni method
begin
  WITH TSearchIniThread.Create(oldLong, oldShrt, newLong, newShrt,
    'INI', AddIni, ReportIni, FailBack) DO
    begin
      OnTerminate := DoneIni;
      Resume;
    end;
end;

procedure TMainForm.DoneReg(Sender: TObject);
// The Registry-processing thread is finished. Show the results
begin
  anChange.Active   := False;
  currUndo          := NextUndoNum;
  SaveForUndo(undobase+IntToStr(currUndo));
  CheckNextPrev;
  Screen.Cursor     := crDefault;
  nbMain.PageIndex  := nbpgFound;
  busy              := False;
  btnAll.Enabled    := unCount+ckCount > 0;
  btnNone.Enabled   := unCount+ckCount > 0;
end;

procedure TMainForm.FailBack(I, stat: Integer);
// The INI and shortcut processing threads report multiple changes
// within a file. If they fail upon trying to save the changed
// file, this method resets all the reported items from that file
// to the specified failure status
VAR N : Integer;
begin
  FOR N := lvMain.Items.Count-1 DOWNTO lvMain.Items.Count-I DO
    WITH lvMain.Items[N] DO
      begin
        WITH TChangeObj(Data) DO
          setFail(stat);
        StateIndex := statFaild;
      end;
end;

end.

