unit warnu;

// Copyright  2001 by Ziff Davis Media, Inc.
// Written by Neil J. Rubenking

// A form used to present new-user warnings and confirmations, with
// the option to NOT show the same warning again.

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TWarnForm = class(TForm)
    Label1  : TLabel;
    Label2  : TLabel;
    btnYes  : TButton;
    btnNo   : TButton;
    cbDont  : TCheckBox;
  private
    { Private declarations }
  public
    { Public declarations }
    procedure SetData(const S1, S2, S3 : String; yesno : Boolean);
  end;

var
  WarnForm: TWarnForm;

implementation

{$R *.DFM}

{ TWarnForm }

procedure TWarnForm.SetData(const S1, S2, S3: String;
  yesno : Boolean);
VAR
  R : TRect;
  Y : Integer;
begin
  Label1.Width := ClientWidth - Label1.Left - 8;
  // Get the correct height for Label1
  FillChar(R, SizeOf(R), 0);
  R.Right := Label1.Width;
  DrawText(Canvas.Handle, PChar(S1), -1, R, DT_CALCRECT OR
    DT_NOPREFIX OR DT_WORDBREAK);
  Label1.Height  := R.Bottom + 4;
  Label1.Caption := S1;
  Y              := Label1.Top + Label1.Height + 8;
  // Place label2, if wanted
  IF S2 <> '' THEN
    begin
      Label2.Caption := S2;
      Label2.Top     := Y;
      Y              := Label2.Top + Label2.Height + 8;
    end
  ELSE Label2.Caption := '';
  cbDont.Caption := S3;
  // Place the remaining controls
  btnYes.Top     := Y;
  btnNo.Top      := Y;
  IF NOT yesno THEN
    begin
      btnNo.Visible  := False;
      btnYes.Caption := 'OK';
    end;
  cbDont.Top := btnYes.Top + btnYes.Height - cbDont.Height;
  // Size the form
  Self.ClientHeight := btnYes.Top + btnYes.Height + 8;
end;

end.
